#ifndef _BSTRING_H
#define _BSTRING_H

#include <fstream>
#include <string>

using namespace std;

class BString
{
friend bool operator==( const BString& lhs, const BString& rhs );
friend ostream& operator<<( ostream& tout, const BString& rhs );
public:
   BString( const char* rhs="" );
   BString( const BString& rhs );
   ~BString();
   BString& operator=( const BString& rhs );
   BString& assign( const BString& rhs );
   const char* c_str() const;
   size_t length() const;
   bool empty() const;
   char& at( int k ) const;
   char& operator[]( int pos ) const;
   BString& operator+=( const BString& rhs );
   BString& append( const BString& rhs );
   void swap( BString& rhs );
   int compare( const BString& rhs ) const;
private:
   struct BStringImpl;
   BStringImpl* bsHandle;
}; // BString

BString operator+( const BString& lhs, const BString& rhs );

struct BStringXptn
{
   enum { allocFailed, outOfRange };
   char funcName[100];
   int  errorCode;
   int  errorValue; 
   BStringXptn( char* mn, int ec, int ev = 0 )
   {  strncpy( funcName, mn, 99 );  funcName[99] = '\0';
      errorCode = ec;  errorValue = ev;  }
}; // BStringXptn

#endif // _BSTRING_H
